#######################################
### MAILBOX PLUGIN 1.0 by stonedegg ###
#######################################
## Players can write !mail <text> in ##
## chat to leave a message to admins ##
## Every message will be stored in a ##
## .txt file in the addons directory ##
#######################################
#######################################


from __future__ import with_statement
from path import path
from time import strftime
import es
import cmdlib


commands = ['!mail', '!mailbox', '!report', '!request', '!feedback']
# Commands for sending the message. Configure to your wishes, but keep the syntax.

MAX_MESSAGES_PER_CONNECT = 3
# Max. number of messages a user can send per connect

info = es.AddonInfo()
info.author      = "stonedegg"
info.name        = "Mailbox"
info.basename    = "mailbox"
info.version     = "1.0"
es.ServerVar('mailbox', info.version).makepublic()

pathtofile = path(__file__).dirname().joinpath('mailbox.txt')


players = {}

def load():
    for cmds in commands:
        cmdlib.registerSayCommand(cmds, mailbox, 'Mailbox Commands')
    for uid in es.getUseridList():
        players[uid] = {}
        players[uid]['count'] = 0

def unload():
    for cmds in commands:
        cmdlib.unregisterSayCommand(cmds)

def player_activate(ev):
    uid = int(ev['userid'])
    players[uid] = {}
    players[uid]['count'] = 0

def player_disconnect(ev):
    uid = int(ev['userid'])
    if uid in players:
        del players[uid]

def mailbox(userid, args):
    if not args:
        es.tell(userid, '#multi', '#lightgreen[ #defaultMailbox #lightgreen] #greenUsage: < #lightgreen!mail text #green> to send a message to an admin.')
    else:
        if userid not in players:
            players[userid] = {}
            players[userid]['count'] = 0
        else:
            if players[userid]['count'] < MAX_MESSAGES_PER_CONNECT:
                players[userid]['count'] += 1
                text = es.getargs()
                time = str(strftime("%a, %d %b %Y %H:%M:%S"))
                File = open(pathtofile, 'a')
                File.write('\n%s [%s] [%s]: %s'%(es.getplayername(userid), es.getplayersteamid(userid), time, text))
                File.close()
                es.tell(userid, '#multi', '#lightgreen[ #defaultMailbox #lightgreen] #greenYour message has been sent!')
            else:
                es.tell(userid, '#multi', '#lightgreen[ #defaultMailbox #lightgreen] #greenMaximum number of messages reached.')
        